.386
.model flat, stdcall
option casemap:none
include windows.inc
include kernel32.inc
includelib kernel32.lib
include user32.inc
includelib user32.lib
include gdi32.inc
includelib gdi32.lib

;**********************************************************************************************************

WinMain proto
WndProc proto hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

;**********************************************************************************************************

IDB_SPLASH      equ 300         ;bitmap resource id

XSIZE           equ 320         ;bitmap width
YSIZE           equ 240         ;bitmap height

;**********************************************************************************************************

.data
ClassName   db "Splish",0
AppName     db "Splash",0

.data?
hInstance   HINSTANCE   ?
hWnd        HWND        ?
hBmp        HBITMAP     ?
hBack       HDC         ?

.code
start:
    invoke GetModuleHandle, NULL
    mov hInstance,eax
    invoke WinMain
    invoke ExitProcess, eax

;** App window stuff **************************************************************************************
WinMain proc
    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG
    mov wc.cbSize,SIZEOF wc
    mov wc.style,CS_HREDRAW or CS_VREDRAW
    mov wc.lpfnWndProc,OFFSET WndProc
    mov wc.cbClsExtra,NULL
    mov wc.cbWndExtra,NULL
    mov eax,hInstance
    mov wc.hInstance,eax
    mov wc.hbrBackground,COLOR_WINDOW+1
    mov wc.lpszMenuName,NULL
    mov wc.lpszClassName,OFFSET ClassName
    invoke LoadIcon, NULL,IDI_APPLICATION
    mov wc.hIcon,eax
    mov wc.hIconSm,eax
    invoke LoadCursor, NULL,IDC_ARROW
    mov wc.hCursor,eax
    invoke RegisterClassEx, ADDR wc
    invoke CreateWindowEx, NULL,ADDR ClassName,ADDR AppName,WS_POPUP or WS_BORDER or WS_SYSMENU,CW_USEDEFAULT,CW_USEDEFAULT,XSIZE,YSIZE,NULL,NULL,hInstance,NULL
    .IF (eax)
        mov hWnd,eax
        invoke ShowWindow, hWnd,SW_SHOWDEFAULT
        invoke UpdateWindow, hWnd
        .WHILE TRUE
            invoke GetMessage, ADDR msg,NULL,0,0
            .BREAK .IF(!eax)
            invoke TranslateMessage, ADDR msg
            invoke DispatchMessage, ADDR msg
        .ENDW
        mov eax,msg.wParam
    .ENDIF
    ret
WinMain endp

WndProc proc hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    LOCAL ps:PAINTSTRUCT
    LOCAL hDC:HDC
    mov eax,uMsg
;-- WM_PAINT ----------------------------------------------------------------------------------------
    .IF (eax==WM_PAINT)
        invoke BeginPaint, hwnd,ADDR ps
        mov hDC,eax
        invoke BitBlt, hDC,0,0,XSIZE,YSIZE,hBack,0,0,SRCCOPY    ;copy the contents of the back dc onto the window
        invoke EndPaint, hwnd,ADDR ps
;-- WM_CREATE ---------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_CREATE)
        invoke GetDC, hwnd                          ;need to know the window's dc (for CreateCompatibleDC)
        mov hDC,eax
        invoke LoadBitmap, hInstance,IDB_SPLASH     ;get a handle to the bitmap resource
        mov hBmp,eax
        invoke CreateCompatibleDC, hDC              ;create somewhere to put the actually bitmap content
        mov hBack,eax
        invoke SelectObject, hBack,hBmp             ;'put' the bitmap into the 'back' DC
        invoke ReleaseDC, hwnd,hDC                  ;release the window's dc again
;-- WM_DESTROY --------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_DESTROY)
        invoke DeleteObject, hBack
        invoke DeleteObject, hBmp
        invoke PostQuitMessage, NULL
;-- default -----------------------------------------------------------------------------------------
    .ELSE
        invoke DefWindowProc, hwnd,uMsg,wParam,lParam
        ret
    .ENDIF
    xor eax,eax
    ret
WndProc endp

end start
